/// <reference types="knockout" />
import { Types } from "./Types";
import { Style } from "./Style";
export declare class FrameworkElement {
    constructor(tagName: string, type: string, options: FrameworkElementOptions);
    getAttribute(attributeName: string): string;
    setAttribute(attribute: Attribute): void;
    deleteAttribute(attributeName: string): void;
    getStyle(cssProperties: Array<Types.CssProperties>): Style;
    setStyle(style: Style, overwriteExisting?: boolean): void;
    deleteStyle(style: Types.CssProperties | Array<Types.CssProperties>): void;
    element: HTMLElement;
    id: string;
    type: string;
    visible: KnockoutObservable<boolean>;
    className: string | KnockoutObservable<string>;
    attributes: {
        [index: string]: string | KnockoutObservable<string>;
    };
    style: Style;
}
export interface FrameworkElementOptions {
    id?: string;
    type?: string;
    visible?: boolean | KnockoutObservable<boolean>;
    className?: string | KnockoutObservable<string>;
    attributes?: Array<Attribute>;
    style?: Style;
}
export interface Attribute {
    name: string;
    value: string | KnockoutObservable<string>;
}
